----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:11:12 07/21/2008 
-- Design Name: 
-- Module Name:    u2_top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-- 9-7-2008 yet to be added
-- LED driver
-- single and double error counters per event, saved in a fifo
-- 3sd1800A polls for these error counts
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use mylib.dcc_pack.all;
---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity LRB is
		generic (sim : boolean := false);
    Port ( clk_p : in  STD_LOGIC; -- system clock in
           clk_n : in  STD_LOGIC; -- system clock in
           lrbA_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbA_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbB_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbB_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbC_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbC_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
-- spare inputs
           CCLK : in  STD_LOGIC; -- system clock in
           CDATA : in  STD_LOGIC; -- system clock in
-- chip ID
           chip_ID : in  STD_LOGIC_VECTOR (2 downto 0);
-- input data
           RXD_p : in  STD_LOGIC;
           RXD_n : in  STD_LOGIC;
-- LED driver
           LED : out  STD_LOGIC_VECTOR (4 downto 0);
-- output data
           TXD_p : out  STD_LOGIC_VECTOR (8 downto 0);
           TXD_n : out  STD_LOGIC_VECTOR (8 downto 0);
-- output clock
           TXclk_p : out  STD_LOGIC;
           TXclk_n : out  STD_LOGIC;
-- DDR pins
           MDQ : inout  STD_LOGIC_VECTOR (15 downto 0);
           MA : out  STD_LOGIC_VECTOR (12 downto 0);
           MBA : out  STD_LOGIC_VECTOR (1 downto 0);
           DM : out  STD_LOGIC_VECTOR (1 downto 0);
           DQS : inout  STD_LOGIC_VECTOR (1 downto 0);
           WE_n : out  STD_LOGIC;
           CAS_n : out  STD_LOGIC;
           RAS_n : out  STD_LOGIC;
           CS_n : out  STD_LOGIC;
           mclke : out  STD_LOGIC;
           mclk : out  STD_LOGIC;
           mclk_n : out  STD_LOGIC
		);
end LRB;

architecture Behavioral of LRB is
constant polarityA : std_logic_vector(3 downto 0) := x"3"; -- used to correct polarity assignment of input LVDS signals
constant polarityB : std_logic_vector(3 downto 0) := x"2"; -- used to correct polarity assignment of input LVDS signals
constant polarityC : std_logic_vector(3 downto 0) := x"6"; -- used to correct polarity assignment of input LVDS signals
signal strobe : std_logic := '0';
signal rst_dcmp: std_logic :='0';
signal rst_dcm: std_logic :='0';
signal clk_in : std_logic := '0';
signal clk : std_logic := '0';
signal clk_q : std_logic := '0';
signal mclk270_dcm: std_logic :='0';
signal mclk90_dcm: std_logic :='0';
signal mclk180_dcm: std_logic :='0';
signal mclk90: std_logic :='0';
signal mclk180: std_logic :='0';
signal mclk270: std_logic :='0';
signal lock: std_logic :='0';
signal reset : std_logic := '0';
signal ps_rdy : std_logic := '0';
signal psdone : std_logic := '0';
signal psincdec : std_logic := '0';
signal psen : std_logic := '0';
signal ps_max : std_logic := '0';
signal ps_min : std_logic := '0';
signal ps_cntr : std_logic_vector(3 downto 0) := (others =>'0');
signal phase_shift : std_logic_vector(7 downto 0) := (others =>'0');
signal dcm_status : std_logic_vector(7 downto 0) := (others =>'0');
signal clk_chk : std_logic := '0';
signal chk_div : std_logic_vector(9 downto 0) := (others =>'0');
signal l_clk : std_logic_vector(2 downto 0) := (others =>'0');
signal LRB_str : std_logic_vector(2 downto 0) := (others =>'0');
signal l0_data : std_logic_vector(27 downto 0) := (others =>'0');
signal l0_status : std_logic_vector(11 downto 0) := (others =>'0');
signal l1_data : std_logic_vector(27 downto 0) := (others =>'0');
signal l1_status : std_logic_vector(11 downto 0) := (others =>'0');
signal l2_data : std_logic_vector(27 downto 0) := (others =>'0');
signal l2_status : std_logic_vector(11 downto 0) := (others =>'0');
signal cc_rxena : std_logic_vector(2 downto 0) := (others =>'0');
signal cc_ecc : std_logic_vector(2 downto 0) := (others =>'0');
signal l0_hq : std_logic_vector(19 downto 0) := (others =>'0');
signal l1_hq : std_logic_vector(19 downto 0) := (others =>'0');
signal l2_hq : std_logic_vector(19 downto 0) := (others =>'0');
signal TXclk : std_logic := '0';
signal RXD : std_logic := '0';
signal TXD : std_logic_vector(8 downto 0) := (others =>'0');
signal cc_rst : std_logic_vector(2 downto 0) := (others =>'0');
signal ch_numberA : std_logic_vector(4 downto 0) := (others =>'0');
signal ch_numberB : std_logic_vector(4 downto 0) := (others =>'0');
signal ch_numberC : std_logic_vector(4 downto 0) := (others =>'0');
signal lfifo_req : std_logic_vector(2 downto 0) := (others =>'0');
signal lfifo_ack : std_logic_vector(2 downto 0) := (others =>'0');
signal lfifo_we : std_logic_vector(2 downto 0) := (others =>'0');
signal lfifo0_data : std_logic_vector(32 downto 0) := (others =>'0');
signal lfifo1_data : std_logic_vector(32 downto 0) := (others =>'0');
signal lfifo2_data : std_logic_vector(32 downto 0) := (others =>'0');
--signal trailer : std_logic_vector(2 downto 0) := (others =>'0');
--signal update : std_logic_vector(2 downto 0) := (others =>'0');
--signal BADID : std_logic_vector(2 downto 0) := (others =>'0');
signal UERR : std_logic_vector(2 downto 0) := (others =>'0');
signal CERR : std_logic_vector(2 downto 0) := (others =>'0');
--signal gc_block : std_logic := '0';
--signal gc_tstrip : std_logic := '0';
--signal gc_idmatch : std_logic := '0';
--signal gc_automon : std_logic := '0';
-- sdram signals
signal rd_event : std_logic := '0';
signal ddr_rqst : std_logic := '0';
signal ddr_read : std_logic := '0';
signal ddr_gnt : std_logic := '0';
signal ddr_addr : std_logic_vector(22 downto 0) := (others =>'0');
signal ddr_length : std_logic_vector(5 downto 0) := (others =>'0');
signal wr_data : std_logic_vector(31 downto 0) := (others =>'0');
signal r_data : std_logic_vector(31 downto 0) := (others =>'0');
signal wr_en : std_logic := '0';
signal mem_data : std_logic_vector(31 downto 0) := (others =>'0');
signal rd_en : std_logic := '0';
-- communication to XC3SD1800A
signal din : std_logic_vector(1 downto 0) := (others =>'0');
signal run : std_logic := '0';
signal vme_end : std_logic := '0';
signal reset_flag : std_logic := '0';
signal reset_flag_dl : std_logic := '0';
signal data_fifo_afull : std_logic := '0';
signal init_cmd_cntr : std_logic_vector(3 downto 0) := (others =>'0');
signal cmd_cntr : std_logic_vector(4 downto 0) := (others =>'0');
signal cmd_srp : std_logic_vector(33 downto 0) := (others =>'0');
signal cmd_sr : std_logic_vector(33 downto 0) := (others =>'0');
signal cmd_srp33_q : std_logic := '0';
signal vme_we_reg : std_logic := '0';
signal vme_we_mem : std_logic := '0';
signal inc_rd_addr : std_logic := '0';
signal vme_rd_wait : std_logic := '0';
signal vme_rd_mem : std_logic := '0';
signal w_data : std_logic_vector(31 downto 0) := (others =>'0');
signal addr : std_logic_vector(9 downto 0) := (others =>'0');
signal ddr_pa : std_logic_vector(13 downto 0) := (others =>'0');
signal vme_rd_wcp : std_logic_vector(4 downto 0) := (others =>'0');
signal vme_rd_wc : std_logic_vector(4 downto 0) := (others =>'0');
signal evt_param : std_logic_vector(22 downto 0) := (others =>'0');
signal latch_high_cnt : std_logic := '0';
--signal dout : std_logic_vector(17 downto 0) := (others =>'0');
signal reg_data : std_logic_vector(31 downto 0) := (others =>'0');
signal send_data : std_logic := '0';
signal out_data : std_logic_vector(35 downto 0) := (others =>'0');
signal tx_data : std_logic_vector(17 downto 0) := (others =>'0');
signal counter : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr0 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr1 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr2 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr3 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr4 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr5 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr6 : std_logic_vector(31 downto 0) := (others =>'0');
signal dbg_cntr7 : std_logic_vector(31 downto 0) := (others =>'0');
type init_array is array(3 downto 0) of bit_vector(15 downto 0);
constant init_value : init_array := (x"0005",x"0008",x"00fc",x"000d");
begin
cc_rst <= "111" when reset = '1' or run = '0' else "000";
cc_ecc <= "111";
--gc_block <= '1';
--gc_tstrip <= '0';
--gc_idmatch <= '1';
--gc_automon <= '1';
ch_numberA <= chip_ID & "00";
ch_numberB <= chip_ID & "01";
ch_numberC <= chip_ID & "10";
i_clock: ibufgds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => clk_p, ib => clk_n, o => clk_in);
i_clk: bufg port map(i => clk_in, o => clk);
i_rst_DCM : SRL16 generic map(INIT => x"ffff")
   port map (
      Q => rst_DCMp,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CLK => clk,   -- Clock input
      D => '0'        -- SRL data input
   );
--rst_DCM <= rst_DCMp when sim else '0';
rst_DCM <= rst_DCMp;
i_DCMmclk: dcm 
   generic map(CLKIN_PERIOD => 10.0,CLKOUT_PHASE_SHIFT => "VARIABLE",PHASE_SHIFT => 0,DESKEW_ADJUST => "SOURCE_SYNCHRONOUS")  
	port map	
         ( CLKIN   => clk ,
           CLKFB   => mclk90 ,
           RST     => rst_dcm ,
           DSSEN   => '0' ,
           PSINCDEC=> psincdec ,
           PSEN    => psen ,
           PSCLK   => mclk90 ,
					 PSDONE => psdone ,
           CLK0    => mclk90_dcm ,
           CLK180    => mclk270_dcm ,
           CLK90  => mclk180_dcm ,
					 STATUS => dcm_status,
           LOCKED  => lock);
mclk180bufg : BUFG port map (O=>mclk180, I=>mclk180_dcm);
mclk90bufg : BUFG port map (O=>mclk90, I=>mclk90_dcm);
mclk270bufg : BUFG port map (O=>mclk270, I=>mclk270_dcm);
process(mclk90)
begin
  if(mclk90'event and mclk90 = '1')then
		clk_q <= clk_in;
	end if;
end process;
process(mclk90,lock)
begin
	if(lock = '0')then
    ps_rdy <= '1';
		psen <= '0';
		psincdec <= '0';
		phase_shift <= x"80";
		ps_cntr <= x"8";
		ps_max <= '0';
		ps_min <= '0';
  elsif(mclk90'event and mclk90 = '1')then
    ps_rdy <= not psen and (ps_rdy or psdone);
		if(psen = '0' and ps_rdy = '1' and (ps_cntr = x"f" or ps_cntr = x"0"))then
			psen <= '1';
			psincdec <= ps_cntr(3);
	  else
			psen <= '0';
	  end if;
		if(psen = '1')then
			if(psincdec = '1' and ps_max = '0')then
				phase_shift <= phase_shift + 1;
			elsif(psincdec = '0' and ps_min = '0')then
				phase_shift <= phase_shift - 1;
			end if;
		end if;
		if(psen = '1')then
			ps_cntr <= x"8";
		elsif(clk_chk = '1' and clk_q = '1' and ps_cntr /= x"0")then
			ps_cntr <= ps_cntr - 1;
		elsif(clk_chk = '1' and clk_q = '0' and ps_cntr /= x"f")then
			ps_cntr <= ps_cntr + 1;
		end if;
		if(phase_shift = x"ff")then
			ps_max <= '1';
		else
			ps_max <= '0';
		end if;
		if(phase_shift = x"00")then
			ps_min <= '1';
		else
			ps_min <= '0';
		end if;
	end if;
end process;
clk_chk <= chk_div(9);
process(mclk90)
begin
  if(mclk90'event and mclk90 = '1')then
	  if(clk_chk = '1')then-- check every 3 microseconds
--		  chk_div <= "0000111111"; -- for 150MHz clock
		  chk_div <= "0011010100"; -- for 100MHz clock
		else
		  chk_div <= chk_div + 1;
		end if;
		strobe <= not strobe;
	end if;
end process;
-- input deserializer
i_deser0: deser PORT MAP(
		clk => mclk90,
		clk_chk => clk_chk,
		l_clk_p => lrbA_in_p(4),
		l_clk_n => lrbA_in_n(4),
		l_data_p => lrbA_in_p(3 downto 0),
		l_data_n => lrbA_in_n(3 downto 0),
		polarity => polarityA,
		l_clkout => l_clk(0),
		strobe => LRB_str(0),
		q => l0_data,
		deser_status => l0_status
	);
i_deser1: deser PORT MAP(
		clk => mclk90,
		clk_chk => clk_chk,
		l_clk_p => lrbB_in_p(4),
		l_clk_n => lrbB_in_n(4),
		l_data_p => lrbB_in_p(3 downto 0),
		l_data_n => lrbB_in_n(3 downto 0),
		polarity => polarityB,
		l_clkout => l_clk(1),
		strobe => LRB_str(1),
		q => l1_data,
		deser_status => l1_status
	);
i_deser2: deser PORT MAP(
		clk => mclk90,
		clk_chk => clk_chk,
		l_clk_p => lrbC_in_p(4),
		l_clk_n => lrbC_in_n(4),
		l_data_p => lrbC_in_p(3 downto 0),
		l_data_n => lrbC_in_n(3 downto 0),
		polarity => polarityC,
		l_clkout => l_clk(2),
		strobe => LRB_str(2),
		q => l2_data,
		deser_status => l2_status
	);
-- hamming correction
i_Hamming0: Hamming PORT MAP(
		clk => l_clk(0),
		strobe => LRB_str(0),
		din => l0_data(23 downto 0),
		cc_rxena => cc_rxena(0),
		cc_ecc => cc_ecc(0),
		dout => l0_hq
	);
i_Hamming1: Hamming PORT MAP(
		clk => l_clk(1),
		strobe => LRB_str(1),
		din => l1_data(23 downto 0),
		cc_rxena => cc_rxena(1),
		cc_ecc => cc_ecc(1),
		dout => l1_hq
	);
i_Hamming2: Hamming PORT MAP(
		clk => l_clk(2),
		strobe => LRB_str(2),
		din => l2_data(23 downto 0),
		cc_rxena => cc_rxena(2),
		cc_ecc => cc_ecc(2),
		dout => l2_hq
	);
i_LVDS0: LVDS PORT MAP(
		l_clk => l_clk(0),
		l_strobe => LRB_str(0),
		strobe => strobe,
		clk => mclk90,
		hq => l0_hq,
		cc_rst => cc_rst(0),
--		gc_block => gc_block,
--		gc_tstrip => gc_tstrip,
--		gc_idmatch => gc_idmatch,
--		gc_automon => gc_automon,
		ch_number => ch_numberA,
		lfifo_ack => lfifo_ack(0),
--		trailer => trailer(0),
		lfifo_req => lfifo_req(0),
		lfifo_we => lfifo_we(0),
		lfifo_data => lfifo0_data,
--		update => update(0),
--		BADID => BADID(0),
		UERR => UERR(0),
		CERR => CERR(0)
	);
ch_numberA <= chip_ID & "00";
i_LVDS1: LVDS PORT MAP(
		l_clk => l_clk(1),
		l_strobe => LRB_str(1),
		strobe => strobe,
		clk => mclk90,
		hq => l1_hq,
		cc_rst => cc_rst(1),
--		gc_block => gc_block,
--		gc_tstrip => gc_tstrip,
--		gc_idmatch => gc_idmatch,
--		gc_automon => gc_automon,
		ch_number => ch_numberB,
		lfifo_ack => lfifo_ack(1),
--		trailer => trailer(1),
		lfifo_req => lfifo_req(1),
		lfifo_we => lfifo_we(1),
		lfifo_data => lfifo1_data,
--		update => update(1),
--		BADID => BADID(1),
		UERR => UERR(1),
		CERR => CERR(1)
	);
ch_numberB <= chip_ID & "01";
i_LVDS2: LVDS PORT MAP(
		l_clk => l_clk(2),
		l_strobe => LRB_str(2),
		strobe => strobe,
		clk => mclk90,
		hq => l2_hq,
		cc_rst => cc_rst(2),
--		gc_block => gc_block,
--		gc_tstrip => gc_tstrip,
--		gc_idmatch => gc_idmatch,
--		gc_automon => gc_automon,
		ch_number => ch_numberC,
		lfifo_ack => lfifo_ack(2),
--		trailer => trailer(2),
		lfifo_req => lfifo_req(2),
		lfifo_we => lfifo_we(2),
		lfifo_data => lfifo2_data,
--		update => update(2),
--		BADID => BADID(2),
		UERR => UERR(2),
		CERR => CERR(2)
	);
ch_numberC <= chip_ID & "10";
i_sdram: sdram_a generic map(sim => sim) PORT MAP(
		reset => reset,
		strobe => strobe,
		mclk0 => not mclk180,
		mclk90 => mclk90,
		mclk180 => mclk180,
		mclk270 => mclk270,
		lock => lock,
		ddr_rqst => ddr_rqst,
		ddr_read => ddr_read,
		ddr_gnt => ddr_gnt,
		ddr_addr => ddr_addr,
		ddr_length => ddr_length,
		wr_data => wr_data,
		wr_en => wr_en,
		rd_en => rd_en,
		rd_data => mem_data,
		mdq => mdq,
		maddr => ma,
		mba => mba,
		dm => dm,
		dqs => dqs,
		we_n => we_n,
		ras_n => ras_n,
		cas_n => cas_n,
		cs_n => cs_n,
		mclke => mclke,
		mclk => mclk,
		mclk_n => mclk_n
	);
-- input event assembling
i_TXclkbuf : OBUFDS generic map(IOSTANDARD => "LVDS_33") port map (O => TXclk_p, OB => TXclk_n, I => TXclk);
i_TXDclkddr : ODDR2
		port map (
      Q => TXclk, -- 1-bit output data
      C0 => not mclk180, -- 1-bit clock input
      C1 => mclk180, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => '1',   -- 1-bit data input (associated with C0)
      D1 => '0',   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
g_TXD: for i in TXD'range generate
	i_TXDbuf : OBUFDS generic map(IOSTANDARD => "LVDS_33") port map (O => TXD_p(i), OB => TXD_n(i), I => TXD(i));
	i_TXDddr : ODDR2
		generic map(DDR_ALIGNMENT => "C0")
		port map (
      Q => TXD(i), -- 1-bit output data
      C0 => mclk90, -- 1-bit clock input
      C1 => mclk270, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => tx_data(i+9),   -- 1-bit data input (associated with C0)
      D1 => tx_data(i),   -- 1-bit data input (associated with C1)
      R => not lock,    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
end generate;
i_RXDbuf: ibufds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => RXD_p, ib => RXD_n, o => RXD);
i_RXDddr : IDDR2
   generic map(DDR_ALIGNMENT => "C0")
   port map (
      Q0 => din(0), -- 1-bit output captured with C0 clock
      Q1 => din(1), -- 1-bit output captured with C1 clock
      C0 => mclk180, -- 1-bit clock input
      C1 => not mclk180, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D => RXD,   -- 1-bit data input 
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
process(mclk90)
begin
  if(mclk90'event and mclk90 = '1')then
		if(cmd_srp(33) = '0' or cmd_cntr(4) = '1')then
			cmd_cntr <= (others => '0');
		elsif(cmd_srp33_q = '0')then
			cmd_cntr <= '0' & init_cmd_cntr;
		else
			cmd_cntr <= cmd_cntr + 1;
		end if;
		if(cmd_cntr(4) = '1')then
			cmd_srp(33 downto 30) <= "00" & din;
		elsif(cmd_srp(33) = '0')then
			cmd_srp(33 downto 30) <= cmd_srp(31 downto 30) & din;
		end if;
		cmd_srp(29 downto 0) <= cmd_srp(27 downto 0) & din;
		cmd_srp33_q <= cmd_srp(33);
		if(cmd_cntr(4) = '1')then
			cmd_sr <= cmd_srp;
		elsif(strobe = '1')then
			cmd_sr <= (others => '0');
		end if;
		if(strobe = '1')then
			if(reset = '1' or ddr_gnt = '1' or run = '1')then
				vme_rd_mem <= '0';
			elsif(cmd_sr(33 downto 30) = x"8" and cmd_sr(15 downto 14) = "11" and cmd_sr(9) = '1')then
				vme_rd_mem <= '1';
			end if;
			if(cmd_sr(33 downto 32) = "11" and addr(9) = '1' and run = '0')then
				vme_we_mem <= '1';
			else
				vme_we_mem <= '0';
			end if;
			if(cmd_sr(33 downto 32) = "11" and addr(9) = '0')then
				vme_we_reg <= '1';
			else
				vme_we_reg <= '0';
			end if;
			if(cmd_sr(33 downto 32) = "11")then
				w_data <= cmd_sr(31 downto 0);
			end if;
			if(reset = '1')then
				evt_param(18 downto 0) <= x"0000" & "000";
			elsif(cmd_sr(33 downto 30) = x"b")then
				evt_param(18 downto 0) <= cmd_sr(19 downto 1);
			end if;
			if(cmd_sr(33 downto 30) = x"b")then
				rd_event <= '1';
			else
				rd_event <= '0';
			end if;
			if(reset = '1')then
				dbg_cntr3 <= (others => '0');
			elsif(rd_event = '1')then
				dbg_cntr3 <= dbg_cntr3 + (x"00000" & "000" & evt_param(8 downto 0)) + 1;
			end if;
			if(reset = '1' or run = '1')then
				evt_param(22 downto 19) <= x"0";
			elsif(cmd_sr(33 downto 30) = x"b" and evt_param(18) = '1' and cmd_sr(19) = '0')then
				evt_param(22 downto 19) <= evt_param(22 downto 19) + 1; -- for LRB test
			end if;
			if(cmd_sr(33 downto 30) = x"8" and cmd_sr(15 downto 14) = "11")then
				vme_rd_wcp <= not cmd_sr(9) & cmd_sr(13 downto 10);
			else
				vme_rd_wcp(4) <= '0';
			end if;
			if(cmd_sr(33 downto 30) = x"8" and cmd_sr(15) = '0')then
				vme_end <= '1';
			else
				vme_end <= '0';
			end if;
			inc_rd_addr <= vme_rd_wc(4) and not vme_rd_wait;
			latch_high_cnt <= inc_rd_addr and addr(8) and not addr(0);
			if(reset = '1')then
				addr <= "1000000000";
			elsif(cmd_sr(33 downto 30) = x"8")then
				addr <= cmd_sr(9 downto 0);
			elsif(inc_rd_addr = '1' or vme_we_reg = '1' or vme_we_mem = '1')then
				addr(8 downto 0) <= addr(8 downto 0) + 1;
			end if;
			if(cmd_sr(33 downto 30) = x"a")then
				data_fifo_afull <= cmd_sr(11);
				reset_flag <= reset_flag xor (cmd_sr(10) and not reset);
				run <= cmd_sr(9);
				led <= not cmd_sr(8 downto 4);
				cc_rxena <= cmd_sr(3 downto 1);
			end if;
			if(reset = '1')then
				ddr_pa <= (others => '0');
			elsif(vme_we_reg = '1' and addr(1 downto 0) = "01")then
				ddr_pa <= w_data(13 downto 0);
			elsif(vme_we_mem = '1' and and_reduce(addr(8 downto 0)) = '1')then
				ddr_pa <= ddr_pa + 1;
			end if;
			if(reset_flag_dl /= reset_flag)then
				reset <= '1';
			else
				reset <= '0';
			end if;
			if(vme_rd_wc(4) = '0')then
				vme_rd_wc <= vme_rd_wcp;
			elsif(vme_rd_wait = '0')then
				vme_rd_wc <= vme_rd_wc - 1;
			end if;
--			if(addr(8) = '1')then
--				reg_data <= counter;
--			else
			case addr(3 downto 0) is
				when x"0" => reg_data <= x"00" & '0' & cc_rxena & '0' & chip_id & LRB_version;
				when x"1" => reg_data <= x"0000" & "00" & ddr_pa;
				when x"2" => reg_data <= x"00000" & l0_status;
				when x"3" => reg_data <= x"00000" & l1_status;
				when x"4" => reg_data <= x"00000" & l2_status;
				when x"5" => reg_data <= x"00000" & not lock & dcm_status(2 downto 0) & phase_shift;
--					when x"6" => reg_data <= dbg_cntr0;
--					when x"7" => reg_data <= dbg_cntr1;
--					when x"8" => reg_data <= dbg_cntr2;
--					when x"9" => reg_data <= dbg_cntr3;
--					when x"a" => reg_data <= dbg_cntr4;
--					when x"b" => reg_data <= dbg_cntr5;
--					when x"c" => reg_data <= dbg_cntr6;
--					when x"d" => reg_data <= dbg_cntr7;
--					when x"e" => reg_data <= dbg_cntr8;
				when others => reg_data <= (others => '0');
			end case;
--			end if;
			if(reset = '1')then
				dbg_cntr7 <= (others => '0');
			elsif(rd_event = '1')then
				dbg_cntr7 <= dbg_cntr7 + 1;
			end if;
		end if;
		if(reset = '1' or send_data = '1')then
			send_data <= '0';
		elsif(out_data(35) = '1')then
			send_data <= '1';
		end if;
		if(send_data = '0')then
			tx_data <= out_data(35 downto 18);
		else
			tx_data <= out_data(17 downto 0);
		end if;
		if(reset = '1')then
			dbg_cntr0 <= (others => '0');
			dbg_cntr1 <= (others => '0');
			dbg_cntr2 <= (others => '0');
		elsif(send_data = '1')then
			if(tx_data(16) = '1')then
				dbg_cntr0 <= dbg_cntr0 + 1;
			end if;
			if(tx_data(16 downto 15) = "01")then
				dbg_cntr1 <= dbg_cntr1 + 1;
			end if;
			if(tx_data(16 downto 15) = "00")then
				dbg_cntr2 <= dbg_cntr2 + 1;
			end if;
		end if;
	end if;
end process;
i_reset_flag_dl: delayN
  generic map(N=> 3) port map(d => reset_flag, ce => strobe, c => mclk90, q => reset_flag_dl);
g_init_cmd_cntr: for i in 0 to 3 generate
	i_init_cmd_cntr : ROM16X1
   generic map (
      INIT => init_value(i))
   port map (
      O => init_cmd_cntr(i),   -- ROM output
      A0 => cmd_srp(30), -- ROM address[0]
      A1 => cmd_srp(31), -- ROM address[1]
      A2 => cmd_srp(32), -- ROM address[2]
      A3 => '0'  -- ROM address[3]
   );
end generate;
i_buffer_ctrl: buffer_ctrl PORT MAP(
		clk => mclk90,
		strobe => strobe,
		reset => reset,
		run => run,
		vme_rd_mem => vme_rd_mem,
		vme_rd_wc => vme_rd_wc,
		vme_rd_wait => vme_rd_wait,
		vme_end => vme_end,
		vme_we_mem => vme_we_mem,
		w_data => w_data,
		ddr_pa => ddr_pa,
		addr => addr,
--		chip_id => chip_id,
		lfifo_req => lfifo_req,
		lfifo_we => lfifo_we,
		lfifoA_data => lfifo0_data,
		lfifoB_data => lfifo1_data,
		lfifoC_data => lfifo2_data,
		lfifo_ack => lfifo_ack,
		ddr_rqst => ddr_rqst,
		ddr_read => ddr_read,
		ddr_gnt => ddr_gnt,
		ddr_addr => ddr_addr,
		ddr_length => ddr_length,
		wr_data => wr_data,
		wr_en => wr_en,
		rd_en => rd_en,
		rd_event => rd_event,
		data_fifo_afull => data_fifo_afull,
		evt_param => evt_param,
		reg_data => r_data,
		mem_data => mem_data,
		dbg_cntr0 => dbg_cntr4,
		dbg_cntr1 => dbg_cntr5,
		dbg_cntr2 => dbg_cntr6,
		out_data => out_data
	);
r_data <= counter when addr(8) = '1' else reg_data;
i_counters: counters PORT MAP(
		clk => mclk90,
		reset => reset,
		strobe => strobe,
		latch_high_cnt => latch_high_cnt,
		uerr => uerr,
		cerr => cerr,
		lfifo0_data => lfifo0_data,
		lfifo1_data => lfifo1_data,
		lfifo2_data => lfifo2_data,
		lfifo_we => lfifo_we,
		addr => addr,
		dout => counter
	);
end Behavioral;

