----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:55:03 03/16/2007 
-- Design Name: 
-- Module Name:    srl_fifo - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity srl_fifo is
    generic (N: integer := 32);
    port (
        rst: 	in STD_LOGIC;
        din: 	in STD_LOGIC_VECTOR (N-1 downto 0);
        w_strobe: 	in STD_LOGIC;
        we: 	in STD_LOGIC;
        clk: 	in STD_LOGIC;
        r_strobe: 	in STD_LOGIC;
        re: 	in STD_LOGIC;
        dav: 	out STD_LOGIC;
        dout: 	out STD_LOGIC_VECTOR (N-1 downto 0);
        rp: 	out STD_LOGIC_VECTOR (3 downto 0)
    );
end srl_fifo;

architecture Behavioral of srl_fifo is
signal q:			std_logic_vector(N-1 downto 0) := (others => '0');
signal a:			std_logic_vector(3 downto 0) := x"f";
signal wep:		std_logic := '1';
signal rep:		std_logic := '1';
signal empty:		std_logic := '1';
signal dav_i:		std_logic := '0';
signal dout_i:	std_logic_vector(N-1 downto 0) := (others => '0');
begin
rp <= a;
dav <= dav_i;
dout <= dout_i;
g1: for i in q'range generate
  srle: srl16e port map(
                             d => din(i),
                             ce => wep,
                             clk => clk,
                             a0 => a(0),
                             a1 => a(1),
                             a2 => a(2),
                             a3 => a(3),
                             q  => q(i));
end generate;
empty <= '1' when a = x"f" else '0'; 
wep <= we and w_strobe;
rep <= re and r_strobe;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(rst = '1')then
			a <= (others => '1');
		elsif(wep /= ((rep or not dav_i) and not empty))then
			if(wep = '1')then
				a <= a + 1;
			else
				a <= a - 1;
			end if;
		end if;
    if(rep = '1' or dav_i = '0')then
      dout_i <= q;
    end if;
		if(rst = '1')then
			dav_i <= '0';
		elsif(a /= x"f")then
			dav_i <= '1';
		elsif(rep = '1')then
			dav_i <= '0';
		end if;
  end if;
end process; 
end Behavioral;

