--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:54:40 09/03/2008
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/u2/buffer_ctrl_tb.vhd
-- Project Name:  u2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: buffer_ctrl
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY buffer_ctrl_tb IS
END buffer_ctrl_tb;
 
ARCHITECTURE behavior OF buffer_ctrl_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
COMPONENT buffer_ctrl
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		start_mem_test : IN std_logic;
		mem_status : IN std_logic_vector(15 downto 0);
		CERR : IN std_logic_vector(2 downto 0);
		UERR : IN std_logic_vector(2 downto 0);
		chip_id : IN std_logic_vector(2 downto 0);
		lfifo_req : IN std_logic_vector(2 downto 0);
		lfifo_we : IN std_logic_vector(2 downto 0);
		lfifoA_data : IN std_logic_vector(32 downto 0);
		lfifoB_data : IN std_logic_vector(32 downto 0);
		lfifoC_data : IN std_logic_vector(32 downto 0);
		wr_gnt : IN std_logic;
		rd_gnt : IN std_logic;
		rd_event : IN std_logic;
		evt_param : IN std_logic_vector(22 downto 0);
		rd_reg : IN std_logic;
		rd_herr_cntr : IN std_logic;
		reg_data : IN std_logic_vector(31 downto 0);
		mem_data : IN std_logic_vector(31 downto 0);          
		lfifo_ack : OUT std_logic_vector(2 downto 0);
		wr_rqst : OUT std_logic;
		wr_addr : OUT std_logic_vector(22 downto 0);
		wr_length : OUT std_logic_vector(5 downto 0);
		wr_data : OUT std_logic_vector(31 downto 0);
		wr_en : OUT std_logic;
		rd_rqst : OUT std_logic;
		rd_addr : OUT std_logic_vector(22 downto 0);
		rd_length : OUT std_logic_vector(5 downto 0);
		rd_en : OUT std_logic;
		out_data : OUT std_logic_vector(35 downto 0)
		);
END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '1';
   signal start_mem_test : std_logic := '0';
   signal chip_id : std_logic_vector(2 downto 0) := (others => '0');
   signal mem_status : std_logic_vector(15 downto 0) := (others => '0');
   signal cerr : std_logic_vector(2 downto 0) := (others => '0');
   signal uerr : std_logic_vector(2 downto 0) := (others => '0');
   signal lfifo_req : std_logic_vector(2 downto 0) := (others => '0');
   signal lfifo_we : std_logic_vector(2 downto 0) := (others => '0');
   signal lfifoA_data : std_logic_vector(32 downto 0) := (others => '0');
   signal lfifoB_data : std_logic_vector(32 downto 0) := (others => '0');
   signal lfifoC_data : std_logic_vector(32 downto 0) := (others => '0');
   signal wr_gnt : std_logic := '0';
   signal rd_gnt : std_logic := '0';
   signal rd_event : std_logic := '0';
   signal evt_param : std_logic_vector(22 downto 0) := (others => '0');
   signal rd_reg : std_logic := '0';
   signal rd_herr_cntr : std_logic := '0';
   signal reg_data : std_logic_vector(31 downto 0) := (others => '0');
   signal mem_data : std_logic_vector(15 downto 0) := (others => '0');

 	--Outputs
   signal lfifo_ack : std_logic_vector(2 downto 0);
   signal wr_rqst : std_logic;
   signal wr_addr : std_logic_vector(22 downto 0);
   signal wr_length : std_logic_vector(5 downto 0);
   signal wr_data : std_logic_vector(31 downto 0);
   signal wr_en : std_logic;
   signal rd_rqst : std_logic;
   signal rd_addr : std_logic_vector(22 downto 0);
   signal rd_length : std_logic_vector(5 downto 0);
   signal rd_en : std_logic;
   signal out_data : std_logic_vector(35 downto 0);

   -- Clock period definitions
   constant clk_period : time := 8ns;
 
signal cntr : std_logic_vector(15 downto 0) := (others => '0');
signal lfifo_wc : std_logic_vector(5 downto 0) := (others => '0');
signal mem_low : std_logic;
signal mem_wc : std_logic_vector(6 downto 0);
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: buffer_ctrl PORT MAP (
          clk => clk,
          reset => reset,
          start_mem_test => start_mem_test,
          mem_status => mem_status,
					chip_id => chip_id,
					cerr => cerr,
					uerr => uerr,
          lfifo_req => lfifo_req,
          lfifo_we => lfifo_we,
          lfifoA_data => lfifoA_data,
          lfifoB_data => lfifoB_data,
          lfifoC_data => lfifoC_data,
          lfifo_ack => lfifo_ack,
          wr_rqst => wr_rqst,
          wr_gnt => wr_gnt,
          wr_addr => wr_addr,
          wr_length => wr_length,
          wr_data => wr_data,
          wr_en => wr_en,
          rd_rqst => rd_rqst,
          rd_gnt => rd_gnt,
          rd_addr => rd_addr,
          rd_length => rd_length,
          rd_en => rd_en,
          rd_event => rd_event,
          evt_param => evt_param,
          rd_reg => rd_reg,
					rd_herr_cntr => rd_herr_cntr,
          reg_data => reg_data,
          mem_data => mem_data,
          out_data => out_data
        );
reg_data <= x"12345678";
rd_reg <= '1' when cntr = x"0024" else '0';
--------------
lfifoA_data(19 downto 0) <= cntr(3 downto 0) & cntr when lfifo_we(0) = '1' else x"000000";
lfifoB_data(19 downto 0) <= cntr(3 downto 0) & cntr when lfifo_we(1) = '1' else x"000000";
lfifoC_data(19 downto 0) <= cntr(3 downto 0) & cntr when lfifo_we(2) = '1' else x"000000";
lfifoA_data(32) <= lfifo_we(0) when lfifo_wc = "000110" else '0';
lfifoB_data(32) <= lfifo_we(1) when (lfifo_wc = "000110" and cntr < x"0040") or cntr = x"0058" else '0';
lfifoC_data(32) <= lfifo_we(2) when lfifo_wc = "000110" else '0';
---------------
rd_event <= '1' when cntr = x"0021" else '0';
evt_param <= "10" & x"123" & '0' & x"3f";
rd_gnt <= '1' when rd_rqst = '1' and cntr(5 downto 0) = "010101" else '0';
---------------
start_mem_test <= '1' when cntr = x"00f0" else '0';
process(clk)
begin
  if(clk'event and clk = '1')then
	  cntr <= cntr + 1;
		if(cntr = x"0024" or cntr = x"0040")then
		  lfifo_req(1) <= '1';
		elsif(lfifo_ack(1) = '1')then
		  lfifo_req(1) <= '0';
		end if;
		if(lfifo_ack(1) = '1')then
		  lfifo_we(1) <= '1';
		elsif((lfifo_wc = "001000" and cntr < x"0040") or lfifo_wc = "010100")then
		  lfifo_we(1) <= '0';
		end if;
		if(lfifo_we = "000")then
			lfifo_wc <= (others => '0');
		else
			lfifo_wc <= lfifo_wc + 1;
		end if;
		if(rd_en = '0')then
			mem_data <= x"0000";
			mem_low <= '1';
			mem_wc <= (others => '0');
		else
			mem_data <= cntr;
			mem_low <= not mem_low;
			if(mem_low = '1')then
				mem_data <= cntr;
			else
				mem_data <= "000000000" & mem_wc;
				mem_wc <= mem_wc + 1;
			end if;
		end if;
--		if(wr_gnt = '1')then
--		  rd_rqst <= '1';
--		elsif(rd_gnt = '1')then
--		  rd_rqst <= '0';
--		end if;
--		if(wr_gnt = '1')then
--		  wr_addr <= wr_addr + 5;
--		end if;
--		if(rd_gnt = '1')then
--		  rd_addr <= rd_addr + 4;
--		end if;
		if(cntr = x"0012")then
			reset <= '0';
		end if;
	end if;
end process;

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
