--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   13:43:19 02/24/2009
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/LRB/counters_tb.vhd
-- Project Name:  LRB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: counters
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY counters_tb IS
END counters_tb;
 
ARCHITECTURE behavior OF counters_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT counters
		generic (cntr_length : integer := 12);
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         strobe : IN  std_logic;
         uerr : IN  std_logic_vector(2 downto 0);
         cerr : IN  std_logic_vector(2 downto 0);
         lfifo0_data : IN  std_logic_vector(32 downto 0);
         lfifo1_data : IN  std_logic_vector(32 downto 0);
         lfifo2_data : IN  std_logic_vector(32 downto 0);
         lfifo_we : IN  std_logic_vector(2 downto 0);
         addr : IN  std_logic_vector(15 downto 0);
         dout : OUT  std_logic_vector(31 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal strobe : std_logic := '0';
   signal uerr : std_logic_vector(2 downto 0) := (others => '0');
   signal cerr : std_logic_vector(2 downto 0) := (others => '0');
   signal lfifo0_data : std_logic_vector(32 downto 0) := (others => '0');
   signal lfifo1_data : std_logic_vector(32 downto 0) := (others => '0');
   signal lfifo2_data : std_logic_vector(32 downto 0) := (others => '0');
   signal lfifo_we : std_logic_vector(2 downto 0) := (others => '0');
   signal addr : std_logic_vector(15 downto 0) := (others => '0');

 	--Outputs
   signal dout : std_logic_vector(31 downto 0);

   -- Clock period definitions
   constant clk_period : time := 10ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: counters generic map (cntr_length => 5) PORT MAP (
          clk => clk,
          reset => reset,
          strobe => strobe,
          uerr => uerr,
          cerr => cerr,
          lfifo0_data => lfifo0_data,
          lfifo1_data => lfifo1_data,
          lfifo2_data => lfifo2_data,
          lfifo_we => lfifo_we,
          addr => addr,
          dout => dout
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
process(clk)
begin
	if(clk'event and clk = '1')then
		strobe <= not strobe;
	end if;
end process;
   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
--      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here
			reset <= '1';
      wait for clk_period*2;
			reset <= '0';
      wait for clk_period*200;
			cerr <= "010";
			lfifo_we <= "010";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*4;
			cerr <= "100";
			lfifo_we <= "100";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*4;
			cerr <= "001";
			lfifo_we <= "001";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*200;
			cerr <= "010";
			lfifo_we <= "010";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*4;
			cerr <= "100";
			lfifo_we <= "100";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*4;
			cerr <= "001";
			lfifo_we <= "001";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*200;
			cerr <= "010";
			lfifo_we <= "010";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*4;
			cerr <= "100";
			lfifo_we <= "100";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait for clk_period*4;
			cerr <= "001";
			lfifo_we <= "001";
      wait for clk_period*32;
			cerr <= "000";
			lfifo_we <= "000";
      wait;
   end process;

END;
